<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');


class Blog extends CI_Model {

var $listing	= array();
var $latest		= array();
var $related	= array();
var $comments	= array();
var $comment	= array();
var $passed		= '1';

public function __construct()
	{
	parent::__construct();
	
	}


public function prepare()
	{
	$this->latest();
	
	$this->listing();
	
	$this->feed();
	
	//echo '<pre>';die(print_r($this));	
	
	}

public function feed()
	{
	if(empty($this->latest) && empty($this->listing))
		{
		//$this->db->cache_on();
		
		$this->latest = $this->db->select('coid, pcoid, contentimportance, contentshowtitle, contentcreated, contenttitle, contentpagetitle, contenttitlecurl, contentphoto, contentclass, contentrelatedclass, contentarticle, contentkeywords, contentdescription')->where(array('contentactive' => 1, 'contenttype' => 'blog'))->order_by('contentcreated', 'desc')->limit(1)->get('content')->row_array();
		
		//$this->db->cache_off();
		if($this->latest['pcoid']!='' && $this->latest['pcoid']!='0')
			{
			$this->latest['parent'] = $this->db->where(array('coid' => $this->latest['pcoid']))->get('content')->row_array();	
			}
		
		$this->page->coids[$this->latest['coid']] = $this->latest['coid'];	
		}
	}

public function latest()
	{
	$this->page->js('blog.inc.js');
	
	if($this->page->coid!='' && in_array('blog/latest', $this->page->elements))
		{
		//$this->db->cache_on();
		
		$this->latest = $this->db->select('coid, contentimportance, contentshowtitle, contentcreated, contenttitle, contentpagetitle, contenttitlecurl, contentphoto, contentclass, contentrelatedclass, contentarticle, contentkeywords, contentdescription')->where(array('pcoid' => $this->page->coid, 'contentactive' => 1))->order_by('contentcreated', 'desc')->limit(1)->get('content')->row_array();
		
		//$this->db->cache_off();
		
		$this->comments();
		
		$this->page->coids[$this->latest['coid']] = $this->latest['coid'];	
		}
	}

public function listing()
	{
	if($this->page->coid!='' && in_array('blog/listing', $this->page->elements))
		{
		// Cacher
		$this->db->start_cache();
		//$this->db->cache_on();
		
		$push = 0;
		$offset = 0;
		
		if(!empty($this->latest))
			{
			$push = 1;
			$this->db->where(array('coid !=' => $this->latest['coid']));
			}
		
		
		$this->db->select('coid, contentimportance, contentshowtitle, contentcreated, contenttitle, contentpagetitle, contenttitlecurl, contentphoto, contentclass, contentrelatedclass, contentarticle, contentkeywords, contentdescription')->where(array('pcoid' => $this->page->coid, 'contentactive' => 1))->order_by('contentcreated', 'desc');
		//$this->db->cache_off();
		$this->db->stop_cache();
		
		$c = $this->db->get('content')->num_rows();
		
		$l = $this->db->limit($this->page->limit, $offset)->get('content')->result_array();
		
		$this->page->paging['coid'] 	= $this->page->coid;
		$this->page->paging['list'] 	= 'blog-listing';
		$this->page->paging['page'] 	= '1';
		$this->page->paging['type'] 	= 'blog';
		$this->page->paging['total'] 	= $c;
		$this->page->paging['offset'] 	= $this->page->limit + $push;
		$this->page->paging['limit'] 	= $this->page->limit;
		
		foreach($l as $r)
			{
			$this->page->coids[$r['coid']] = $r['coid'];	
			}
		
		$this->db->flush_cache();
		
		$this->listing = $l;
		}
	
	if($this->page->info['pcoid']!='')
		{
		//$this->db->cache_on();
		$r = $this->db->where(array('pcoid' => $this->page->info['pcoid'], 'contentactive' => 1))->order_by('contentcreated', 'desc')->limit($this->page->limit)->get('content')->result_array();
		//$this->db->cache_off();
		}
	
	if($this->page->site['ajaxpaging']==1)
		{
		$this->page->js('jquery.inviewport.js');
		$this->page->js('jquery.paging.js');	
		}
	//echo '<pre>';die(print_r($this->page->schema));	
	}


public function paging()
	{
	if(!isset($this->page->postdata['offset']))
		{
		$this->page->error('The current page number is missing.');
		}
	else
		{
		$this->page->paging['coid'] 	= $this->page->postdata['coid'];
		$this->page->paging['list'] 	= $this->page->postdata['listid'];
		$this->page->paging['total'] 	= $this->page->postdata['total'];
		$this->page->paging['offset'] 	= $this->page->postdata['offset'];
		$this->page->paging['limit'] 	= $this->page->postdata['limit'];
		
		$this->page->paging['finish']	= $this->page->paging['offset'] + $this->page->paging['limit'];
		
		$q = $this->db->where(array('pcoid' => $this->page->paging['coid']))->order_by('contentcreated', 'desc')->limit($this->page->paging['limit'], $this->page->paging['offset'])->get('content')->result_array();
		
		if(!empty($q))
			{
			$this->blog->listing = $q;
			
			$this->page->inline = 1;
			
			$this->page->response('offset',  $this->page->paging['finish']);
			
			$this->page->response('output',  $this->page->element('blog/inline/listing'));
			
			$this->page->success('More records found. Add them to your list.');
			}
		else
			{
			
			$this->page->success('No more records. :P');
			$this->page->response('endoftheline',  1);	
			}
		}
	
	$this->page->respond();
	}

public function comments()
	{
	$this->comments = $this->db->where(array('coid' => $this->page->coid, 'commentvisible' => 1))->order_by('commenttime', 'desc')->get('contentcomments')->result_array();	
	}


public function comment()
	{
	$this->page->required(array(	'your-name' 	=> 'You must input your name.',
									'your-position' => 'You must tell us your job / position. Help others understand your background.',
									'your-comment' 	=> 'You must put some text in for your comment. :P',
									));	
	
	$this->page->validate();
	
	if(!isset($this->page->response['error']))
		{
		$exc = array();
		
		
		$comment = array(	'coid' => $this->page->postdata['your-article'],
							'commentvisible' => $this->passed,
							'commenttime' => time(),
							'commentname' => $this->page->postdata['your-name'],
							'commentemail' => $this->page->postdata['your-email'],
							'commentposition' => $this->page->postdata['your-position'],
							'commentbody' => $this->page->postdata['your-comment'],
							);
		
		if($this->db->insert('contentcomments', $comment))
			{
			if($this->passed=='1')
				{
				$this->page->success('Thanks for your comment.');
				
				$this->page->inline = 1;
				
				$this->blog->comment = $comment;
				
				$view = $this->page->element('blog/inline/comment');
				
				$this->page->response('comment', $view);	
				}
			else
				{
				$this->page->success('Thanks for your comment. It has been submitted for review by the administrator.');	
				}
			}
		else
			{
			$this->page->error('Sorry but there was an error saving your comment to the system. This has been logged and it will be looked at. Sorry about this :(');	
			}
		}
	
	$this->page->respond();
	}


public function filtering()
	{
	$filters = array('sex', 'fuck', 'shit', 'fag', );
	
	foreach($this->page->postdata as $k => $v)
		{
		foreach($filters as $f)
			{
			if(strpos($v, $f) > 0)
				{
				$this->passed = '2';
				}
			}
		}
	}








}

